apps/clients/urls.py
from django.conf.urls import url

from .views import ListClientView, CreateClientView, UpdateClientView, DeleteClientView, RemoveClientView, \
    LoadClientsAPI, LoadProvincesAPI, LoadDistrictsAPI, ValidateRucView

urlpatterns = [
    url(r'^$', ListClientView.as_view(), name='client-list'),
    url(r'nuevo/$', CreateClientView.as_view(), name='client-create'),
    url(r'editar/(?P<pk>\d+)/$', UpdateClientView.as_view(), name='client-edit'),
    url(r'eliminar/(?P<pk>\d+)/$', DeleteClientView.as_view(), name='client-delete'),
    url(r'^cliente/(?P<pk>\d+)/remover/$', RemoveClientView.as_view(),
        name='remover-cliente'),
    url(r'^clientes/$', LoadClientsAPI.as_view(), name='clients-api'),

    url(r'department/(?P<pk>\d+)/provinces$', LoadProvincesAPI.as_view(), name='load-provinces'),
    url(r'province/(?P<pk>\d+)/districts$', LoadDistrictsAPI.as_view(), name='load-districts'),
    url(r'validateRuc/$', ValidateRucView.as_view(), name='validate-ruc'),
]

corebackend/urls.py
from django.conf import settings
from django.conf.urls import url, include
from django.conf.urls.static import static
from django.contrib import admin
from django.views.static import serve

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'', include('apps.clients.urls', namespace='clients', app_name='clients')),
    url(r'', include('apps.products.urls', namespace='products', app_name='products')),
    url(r'^oportunidad-venta/', include('apps.sale_opportunity.urls',
                                        namespace='sale_opportunity', app_name='sale_opportunity')),
    url(r'^seguridad/', include('apps.security.urls',
                                namespace='security', app_name='security'))
]

if settings.DEBUG:
    urlpatterns += [
                       url(r'^media/(?P<path>.*)$', serve, {
                           'document_root': settings.MEDIA_ROOT,
                       }),
                       url(r'^static/(?P<path>.*)$', serve,
                           {'document_root': settings.STATIC_ROOT,
                            })
                   ] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

apps/clients/forms.py
from django import forms
from django.forms import widgets

from apps.clients.models import Client, Department, District
from apps.common.constants import RUC


class CreateClientForm(forms.ModelForm):
    address = forms.CharField(
        label='Dirección del Cliente',
        required=False,
        widget=forms.TextInput(attrs={
            'maxlength': '100',
            'type': 'text',
        })
    )
    department = forms.ModelChoiceField(
        label="Departamento",
        queryset=Department.objects.all(),
        required=False,
        widget=forms.Select(attrs={
            "class": "js-select2",
        })
    )
    district = forms.ModelChoiceField(
        label='Distrito',
        queryset=District.objects.all(),
        required=False,
    )
    phone_1 = forms.CharField(
        label='Teléfono 1',
        required=False,
        widget=forms.TextInput(attrs={
            'maxlength': '9',
            'type': 'text',
            'class': 'form-control',
            'pattern': "[0-9.]+"
        })
    )
    phone_2 = forms.CharField(
        label='Teléfono 2',
        required=False,
        widget=forms.TextInput(attrs={
            'maxlength': '9',
            'type': 'text',
            'class': 'form-control ancho20',
            'pattern': "[0-9.]+"
        })
    )
    email_contact = forms.EmailField(
        label='Email Contacto',
        required=False,
        widget=forms.TextInput(attrs={
            'class': 'form-control',
            'type': 'email',
        })
    )
    contact_name = forms.CharField(
        label='Contacto',
        required=False,
        widget=forms.TextInput(attrs={
            'maxlength': '200',
            'type': 'text',
        })
    )
    type_doc = forms.ChoiceField(
        label="Tipo Documento",
        choices=Client.TYPES_DOCS,
        initial=RUC,
        required=False,
        widget=forms.Select(attrs={
            "class": "js-select2",
        })
    )
    name = forms.CharField(
        required=False,
        label="Razón Social",
        widget=forms.TextInput(
            attrs={
                "maxlength": 120,
                "class": "form-control",
            }
        ))
    paternal_surname = forms.CharField(
        required=False,
        label="Ap. Paterno",
        widget=forms.TextInput(
            attrs={
                "maxlength": 30,
                "class": "form-control",
            }
        ))
    maternal_surname = forms.CharField(
        required=False,
        label="Ap. Materno",
        widget=forms.TextInput(
            attrs={
                "maxlength": 30,
                "class": "form-control",
            }
        ))
    first_name = forms.CharField(
        required=False,
        label="Primer Nombre",
        widget=forms.TextInput(
            attrs={
                "maxlength": 30,
                "class": "form-control",
            }
        ))
    second_name = forms.CharField(
        required=False,
        label="Segundo Nombre",
        widget=forms.TextInput(
            attrs={
                "maxlength": 30,
                "class": "form-control",
            }
        ))
    type_person_sunat = forms.ChoiceField(
        label="Tipo Persona",
        choices=Client.TYPES_PERSON,
        initial=Client.TPJ,
        required=False
    )
    email_fact = forms.EmailField(
        label='Correo de Empresa',
        required=False,
        widget=forms.TextInput(attrs={
            'class': 'form-control',
            'type': 'email',
        })
    )
    comments = forms.CharField(
        max_length=1200,
        required=False, label="Descripcion",
        widget=widgets.Textarea(attrs={
            'class': 'form-control no-resize',
            'rows': '2',
            'maxlength': '1200'
        })
    )

    client_group = forms.ChoiceField(
        label="Tipo Cliente:",
        choices=Client.CLIENT_GROUPS,
        required=False
    )

    num_doc = forms.CharField(
        required=False,
        label="Número de Documento",
        widget=forms.TextInput(
            attrs={
                "class": "form-control",
            }
        )
    )
    image = forms.FileField(
        required=False,
        label='Adjuntar',
        widget=widgets.FileInput(attrs={
            'type': 'file',
            'class': 'custom-file-input',
            'accept': 'image/*'
        })
    )

    class Meta:
        model = Client
        fields = ['type_doc', 'num_doc', 'type_person_sunat', 'name', 'paternal_surname', 'maternal_surname',
                  'first_name', 'second_name', 'client_group', 'email_fact', 'comments', 'image', 'address',
                  'contact_name', 'phone_1', 'phone_2', 'email_contact']

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        client = self.instance
        address = client.addresses.last()
        contact = client.contacts.last()
        if address:
            self.initial['address'] = address.address
        if contact:
            self.initial['phone_1'] = contact.phone_1
            self.initial['phone_2'] = contact.phone_2
            self.initial['email_contact'] = contact.email
            self.initial['contact_name'] = contact.name

    def clean(self):
        cleaned_data = super().clean()

        district_data = self.data.get('district')

        if district_data is not None and district_data is not '':
            district = District.objects.get(pk=self.data.get('district'))
            cleaned_data['district'] = district

        return cleaned_data

apps/clients/views.py
from django.contrib import messages
from django.http import HttpResponseRedirect

# Create your views here.
from django.urls import reverse, reverse_lazy
from django.views import View
from django.views.generic import ListView, CreateView, UpdateView, DeleteView
from rest_framework import filters
from rest_framework.generics import ListAPIView
from rest_framework.response import Response
from rest_framework.status import HTTP_200_OK
from rest_framework.views import APIView

from apps.clients.forms import CreateClientForm
from apps.clients.serializers import ClientSerializer, ProvinceSerializer, DistrictSerializer
from apps.clients.utils import valid_client
from apps.common.constants import RUC
from apps.security.views import LoginPermissionView
from .models import Client, Contact, Address, Province, District


class ListClientView(LoginPermissionView, ListView):
    model = Client
    template_name = 'clients/client_list.html'
    context_object_name = 'clients'
    permission_required = 'gesco.clients-list'

    def get_queryset(self):
        if self.request.user.is_superuser:
            return Client.objects.filter(is_deleted=False).order_by('-created_at')

        return self.request.user.clients.filter(is_deleted=False).order_by('-created_at')


class CreateClientView(LoginPermissionView, CreateView):
    model = Client
    form_class = CreateClientForm
    template_name = 'clients/client_create.html'
    success_url = reverse_lazy('clients:client-list')
    permission_required = 'gesco.clients-create'

    def form_valid(self, form, **kwargs):
        contexto = self.get_context_data(**kwargs)
        mensaje = 'Debe ingresar el campo '
        if form.is_valid():
            is_valid, form = valid_client(form, mensaje)
            contexto['form'] = form
        if not form.is_valid():
            contexto['form'] = form
            return self.render_to_response(contexto)
        else:
            client = form.save(commit=False)
            address = form.cleaned_data.get('address')
            phone_1 = form.cleaned_data.get('phone_1')
            phone_2 = form.cleaned_data.get('phone_2')
            email_contact = form.cleaned_data.get('email_contact')
            contact_name = form.cleaned_data.get('contact_name')
            name = form.cleaned_data.get('name')
            paternal_surname = form.cleaned_data.get('paternal_surname')
            maternal_surname = form.cleaned_data.get('maternal_surname')
            first_name = form.cleaned_data.get('first_name')
            second_name = form.cleaned_data.get('second_name')
            district = form.cleaned_data.get('district')

            type_doc = form.cleaned_data.get('type_doc')
            if type_doc != RUC:
                name = '{} {} {} {}'.format(first_name, second_name, paternal_surname, maternal_surname)
            client.name = name
            client.user = self.request.user
            client.save()
            Contact.objects.create(name=contact_name, phone_1=phone_1, phone_2=phone_2, email=email_contact,
                                   client=client)
            Address.objects.create(address=address, client=client, district=district)
        return super(CreateClientView, self).form_valid(form)


class UpdateClientView(LoginPermissionView, UpdateView):
    model = Client
    template_name = 'clients/client_create.html'
    form_class = CreateClientForm
    permission_required = 'gesco.clients-update'
    success_url = reverse_lazy('clients:client-list')

    def form_valid(self, form, **kwargs):
        contexto = self.get_context_data(**kwargs)
        mensaje = 'Debe ingresar el campo '
        if form.is_valid():
            is_valid, form = valid_client(form, mensaje)
            contexto['form'] = form
        if not form.is_valid():
            contexto['form'] = form
            return self.render_to_response(contexto)
        else:
            client = form.save(commit=False)
            address = form.cleaned_data.get('address')
            phone_1 = form.cleaned_data.get('phone_1')
            phone_2 = form.cleaned_data.get('phone_2')
            email_contact = form.cleaned_data.get('email_contact')
            contact_name = form.cleaned_data.get('contact_name')
            name = form.cleaned_data.get('name')
            paternal_surname = form.cleaned_data.get('paternal_surname')
            maternal_surname = form.cleaned_data.get('maternal_surname')
            first_name = form.cleaned_data.get('first_name')
            second_name = form.cleaned_data.get('second_name')
            type_doc = form.cleaned_data.get('type_doc')
            district = form.cleaned_data.get('district')

            if type_doc != RUC:
                name = '{} {} {} {}'.format(first_name, second_name, paternal_surname, maternal_surname)
            client.name = name
            client.save()
            contact = self.object.contacts.last()
            if contact:
                contact.phone_1 = phone_1
                contact.phone_2 = phone_2
                contact.email = email_contact
                contact.name = contact_name
                contact.save(update_fields=['name', 'phone_1', 'phone_2', 'email'])

            object_address = self.object.addresses.last()
            if object_address:
                object_address.address = address
                object_address.district = district
                object_address.save(update_fields=['address', 'district'])
        return super(UpdateClientView, self).form_valid(form)


class DeleteClientView(LoginPermissionView, DeleteView):
    model = Client
    success_url = reverse_lazy('clients:client-list')
    template_name_suffix = '_confirm_delete'
    permission_required = 'gesco.clients-delete'


class RemoveClientView(LoginPermissionView, View):
    permission_required = 'gesco.clients-delete'
    client = None

    def remover(self, request, *args, **kwargs):
        self.client = Client.objects.get(id=self.kwargs['pk'])
        self.client.is_deleted = True
        self.client.save(update_fields={'is_deleted'})
        return HttpResponseRedirect(self.get_success_url())

    def post(self, request, *args, **kwargs):
        return self.remover(request, *args, **kwargs)

    def get_success_url(self):
        messages.success(self.request,
                         'Cliente {} eliminado con éxito.'.format(
                             self.client.name))

        return reverse('clients:client-list')


class LoadClientsAPI(ListAPIView):
    serializer_class = ClientSerializer
    queryset = Client.objects.exclude(is_deleted=True)
    filter_backends = (filters.SearchFilter,)
    search_fields = ('name',)

    def get_queryset(self):
        c =Client.objects.exclude(is_deleted=True).filter(
            name__icontains=self.request.query_params.get('q'))
        for c in c:
            print(c)
        return Client.objects.exclude(is_deleted=True).filter(
            name__icontains=self.request.query_params.get('q')
        )


class LoadProvincesAPI(ListAPIView):
    serializer_class = ProvinceSerializer

    def get_queryset(self):
        return Province.objects.filter(department=self.kwargs['pk'])


class LoadDistrictsAPI(ListAPIView):
    serializer_class = DistrictSerializer

    def get_queryset(self):
        return District.objects.filter(province=self.kwargs['pk'])


class ValidateRucView(APIView):

    def post(self, request, *args, **kwargs):
        ruc = self.request.POST.get('ruc')
        exception = self.request.POST.get('exception')

        if ruc == exception:
            return Response(status=HTTP_200_OK, data={'alreadyExisted': False})

        already_existed = Client.objects.filter(num_doc__iexact=ruc).filter(type_doc=RUC).count() > 0

        return Response(status=HTTP_200_OK, data={'alreadyExisted': already_existed})

templates/clients/client_confirm_delete.html
<form method="post">{% csrf_token %}
    <p>Esta seguro de eliminar {{ object }}?</p>
    <input type="submit" value="Confirmar">
</form>

templates/clients/client_list.html
{% extends 'basepartials/base.html' %}
{% load static %}
{% block title %}Clientes{% endblock %}

{% block extra_style %}
<link href="{% static 'vendor/datatable/css/dataTables.bootstrap4.min.css' %}" rel="stylesheet"/>
<style>
  .dataTables_filter {display: none;}
</style>
{% endblock %}
{% block content %}
{% if messages %}
    {% include 'basepartials/_messages.html' %}
{% endif %}
<div class="container container-full">
    <div class="card" style="padding: 0;">
        <div class="card-body" style="margin:0;">
            <div class="row">
                <div class="col-md-3">
                    <h2>Lista de Clientes</h2>
                </div>
                <div class="col-md-9" style="text-align: right">
                    <div id="buttons-op">
                        <a href="{% url 'clients:client-create' %}" type="button"
                           class="btn btn-default btn-lg btn-light"
                           data-toggle="tooltip" title="Nuevo Cliente" style="padding: 5px 5px 0;margin: 0 10px 10px 0;">
                            <ion-icon style="width: 32px;height: 30px;" name="person-add"></ion-icon>
                        </a>
                    </div>
                </div>
            </div>

            <table id="clients" class="table table-striped table-bordered" style="width:100%">
                <thead>
                <tr style="background-color: #337ab7; color: white;">
                    <th>RUC</th>
                    <th>Razón Social</th>
                    <th>Tipo Persona</th>
                    <th>Contacto</th>
                    <th>Dirección</th>
                    <th>Usuario</th>
                    <th>Fecha de creación</th>
                    <th>Editar/Eliminar</th>
                </tr>
                <tr id="tr_search">
                    <th></th>
                    <th></th>
                    <th></th>
                    <th></th>
                    <th></th>
                    <th></th>
                    <th></th>
                    <th id="th-buttons"></th>
                </tr>

                </thead>
                <tbody>
                {% for client in clients %}
                <tr id="{{ client.id }}">
                    {% if client.type_person_sunat == "TPJ" %}
                    <td> {{ client.num_doc }}</td>
                    {% else %}
                    <td></td>
                    {% endif %}
                    <td>{{ client.name }}</td>
                    {% if client.type_person_sunat == "TPJ" %}
                        <td> JURÍDICA </td>
                    {% elif client.type_person_sunat == "TPN" %}
                        <td> NATURAL </td>
                    {% elif client.type_person_sunat == "SND" %}
                        <td> NO DOMICILIADO </td>
                    {% else %}
                        <td> {{ client.type_person_sunat }} </td>
                    {% endif %}
                    <td>{{ client.contact_full_name }}</td>
                    <td>{{ client.address }}</td>
                    <td>{{ client.user.username|default_if_none:'' }}</td>
                    <td>{{ client.user.staff.created_at|date:"d/m/Y" }}</td>
                    <td>
                        <a href="{% url 'clients:client-edit' client.id %}"
                           type="button"
                           class="btn-light" >
                            <img class="img-light-small"
                               src="{% static 'img/edit.png' %}" alt="" width="20"></a>
                <!--<a href="{% url 'clients:client-delete' client.id %}" type="button" class="btn btn-warning">Eliminar</a>-->
                        <a href="#" id="remover"
                           type="button"
                           class="btn-light"
                           title="Eliminar Cliente"
                           data-toggle="modal"
                           data-target="#modalClientDelete"
                        >
                           <img class="img-light-small"
                               src="{% static 'img/delete.png' %}" alt="" width="20"></a>
                        </a>
                    </td>
                </tr>
                {% endfor %}
                </tbody>
            </table>
          <input type="hidden" id="selectedRow">
        </div>
    <!-- The Modal -->
        <div class="modal fade" id="modalClientDelete">
          <div class="modal-dialog">
            <div class="modal-content">

              <!-- Modal Header -->
              <div class="modal-header">
                <h4 class="modal-title">Eliminar Cliente</h4>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
              </div>

              <!-- Modal body -->
              <div class="modal-body">
                ¿ Está seguro de eliminar el registro del cliente ?
              </div>

              <!-- Modal footer -->
              <div class="modal-footer">
                <button type="button"
                        class="btn btn-danger"
                        data-dismiss="modal">
                    Cancelar
                </button>
                <button id="btnRemoverConfirmacion"
                        type="button"
                        class="btn btn-default"
                        data-dismiss="modal">
                    Eliminar
                </button>
                <form id="remover-cliente" style="display: inline"
                      action=""
                      method="post">{% csrf_token %}
                </form>
              </div>

            </div>
          </div>
        </div>
    <!--
        <div class="modal fade" id="confirmationModal" role="dialog">
                <div class="modal-dialog">

                  <div class="modal-content">
                    <div class="modal-header">
                      <button type="button" class="close" data-dismiss="modal">&times;</button>
                      <h4 align="left" class="modal-title">ELIMINAR CLIENTE</h4>
                    </div>
                    <div class="modal-body">
                      <p align="left"> ¿Está seguro de eliminar el registro del CLiente?</p>
                    </div>
                    <div class="modal-footer">
                      <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
                      <button id="btnRemoverConfirmacion" type="button" class="btn btn-default" data-dismiss="modal">
                        Eliminar
                      </button>
                      <form id="remover-expediente" style="display: inline"
                            action=""
                            method="post">{% csrf_token %}
                      </form>
                    </div>
                  </div>
                </div>
        </div>
    -->
    </div>
</div>
{% endblock %}
{% block bottom_scripts %}
<script src="{% static 'vendor/datatable/js/jquery.dataTables.min.js' %}"></script>
<script src="{% static 'vendor/datatable/js/dataTables.bootstrap4.min.js' %}"></script>
<script>
    window.urls = {
              removercliente: "{% url 'clients:remover-cliente' 999 %}",

    }
</script>
<script src="{% static 'js/datatable.js' %}"></script>
<script src="{% static 'js/client-list.js' %}"></script>
<script>

  $('#modalClientDelete').on('show.bs.modal', function (event) {
    var button = $(event.relatedTarget);
    $("#selectedRow").val(button.parent().parent()[0].id);
  })
</script>
{% endblock %}